#ifndef INC_CMMParser_hpp_
#define INC_CMMParser_hpp_

#include <antlr/config.hpp>
/* $ANTLR 2.7.4: "CMM.gpp" -> "CMMParser.hpp"$ */
#include <antlr/TokenStream.hpp>
#include <antlr/TokenBuffer.hpp>
#include "CMMLexerTokenTypes.hpp"
#include <antlr/LLkParser.hpp>

ANTLR_BEGIN_NAMESPACE(gibbon)
#line 5 "CMM.gpp"

  ANTLR_END_NAMESPACE
  #include "CMM.hpp"
  ANTLR_BEGIN_NAMESPACE(gibbon)

#line 18 "CMMParser.hpp"
class CUSTOM_API CMMParser : public antlr::LLkParser, public CMMLexerTokenTypes
{
#line 1 "CMM.gpp"
#line 22 "CMMParser.hpp"
public:
	void initializeASTFactory( antlr::ASTFactory& factory );
protected:
	CMMParser(antlr::TokenBuffer& tokenBuf, int k);
public:
	CMMParser(antlr::TokenBuffer& tokenBuf);
protected:
	CMMParser(antlr::TokenStream& lexer, int k);
public:
	CMMParser(antlr::TokenStream& lexer);
	CMMParser(const antlr::ParserSharedInputState& state);
	int getNumTokens() const
	{
		return CMMParser::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return CMMParser::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return CMMParser::tokenNames;
	}
	public:  string  identifier();
	public:  CmmContName *  cont_name();
	public:  CmmSimpName *  simple_name();
	public:  CmmSpecialFuction *  special_function();
	public:  CmmNameExpr *  id_expr();
	public:  CmmExpr *  primary_expr();
	public:  CmmValueExpr *  literal_expr();
	public:  CmmThisExpr *  this_expr();
	public:  CmmSubexprExpr *  subexpr_expr();
	public:  string  literal();
	public:  CmmExpr *  expr();
	public:  CmmExpr *  postfix_start();
	public:  CmmModernCastExpr *  modern_cast_expr();
	public:  CmmTypeidExpr *  typeid_expr();
	public:  CmmTypeId *  type_id();
	public:  CmmExpr *  postfix_expr();
	public:  CmmIndexExpr *  index_expr(
		 CmmExpr * store 
	);
	public:  CmmCallExpr *  call_expr(
		 CmmExpr * store 
	);
	public:  CmmFieldExpr *  field_expr(
		 CmmExpr * store 
	);
	public:  CmmPtrFieldExpr *  ptr_field_expr(
		 CmmExpr * store 
	);
	public:  CmmPostIncExpr *  post_inc_expr(
		 CmmExpr * store 
	);
	public:  CmmPostDecExpr *  post_dec_expr(
		 CmmExpr * store 
	);
	public:  CmmExprList *  expr_list();
	public:  CmmExpr *  assignment_expr();
	public:  CmmExpr *  unary_expr();
	public:  CmmIncExpr *  inc_expr();
	public:  CmmDecExpr *  dec_expr();
	public:  CmmDerefExpr *  deref_expr();
	public:  CmmAddrExpr *  addr_expr();
	public:  CmmPlusExpr *  plus_expr();
	public:  CmmMinusExpr *  minus_expr();
	public:  CmmBitNotExpr *  bit_not_expr();
	public:  CmmLogNotExpr *  log_not_expr();
	public:  CmmSizeofExp *  sizeof_expr();
	public:  CmmNewExpr *  allocation_expr();
	public:  CmmDeleteExpr *  deallocation_expr();
	public:  CmmExpr *  cast_expr();
	public:  CmmAllocTypeSpecSect *  alloc_type_specifier_list();
	public:  CmmNewArrayLimit *  allocation_array_limit();
	public:  CmmCastFormula *  cast_formula();
	public:  CmmExpr *  pm_expr();
	public:  CmmExpr *  multiplicative_expr();
	public:  CmmExpr *  additive_expr();
	public:  CmmExpr *  shift_expr();
	public:  CmmExpr *  relational_expr();
	public:  CmmExpr *  equality_expr();
	public:  CmmExpr *  and_expr();
	public:  CmmExpr *  exclusive_or_expr();
	public:  CmmExpr *  inclusive_or_expr();
	public:  CmmExpr *  logical_and_expr();
	public:  CmmExpr *  logical_or_expr();
	public:  CmmExpr *  conditional_expr();
	public:  CmmCondExpr *  conditional_cont_expr(
		 CmmExpr * store 
	);
	public:  CmmExpr *  simple_assignment_expr();
	public:  CmmThrowExpr *  throw_expr();
	public:  CmmExpr *  const_expr();
	public:  CmmStatSect *  stat_list();
	public:  CmmStat *  stat();
	public:  CmmExprStat *  expression_stat();
	public:  CmmDeclStat *  declaration_stat();
	public:  CmmCompoundStat *  compound_stat();
	public:  CmmLabeledStat *  labeled_stat();
	public:  CmmCaseStat *  case_stat();
	public:  CmmDefaultStat *  default_stat();
	public:  CmmEmptyStat *  empty_stat();
	public:  CmmIfStat *  if_stat();
	public:  CmmSwitchStat *  switch_stat();
	public:  CmmWhileStat *  while_stat();
	public:  CmmDoStat *  do_stat();
	public:  CmmForStat *  for_stat();
	public:  CmmBreakStat *  break_stat();
	public:  CmmContinueStat *  continue_stat();
	public:  CmmReturnStat *  return_stat();
	public:  CmmGotoStat *  goto_stat();
	public:  CmmTryStat *  try_stat();
	public:  CmmDirectiveStat *  directive_stat();
	public:  CmmIntoStat *  into_stat();
	public:  CmmDefineStat *  define_stat();
	public:  CmmGroupStat *  group_stat();
	public:  CmmIndentStat *  indent_stat();
	public:  CmmWhenStat *  when_stat();
	public:  CmmCallStat *  call_stat();
	public:  CmmSpaceStat *  space_stat();
	public:  CmmLocationStat *  location_stat();
	public:  CmmSuperStat *  super_stat();
	public:  CmmStat *  inner_stat();
	public:  CmmStat *  tail_stat();
	public:  CmmDecl *  block_declaration();
	public:  CmmCondition *  condition();
	public:  CmmSimpleDecl *  simple_declaration();
	public:  CmmDeclSect *  declaration_list();
	public:  CmmDecl *  declaration();
	public:  CmmCtorHead *  constructor_head();
	public:  CmmCtorDecl *  constructor_declaration();
	public:  CmmFuncHead *  function_head();
	public:  CmmFuncDecl *  function_declaration();
	public:  CmmEmptyDecl *  empty_declaration();
	public:  CmmNamespace *  namespace_definition();
	public:  CmmUsingDecl *  using_declaration();
	public:  CmmAsmDecl *  asm_declaration();
	public:  CmmTemplateDecl *  template_declaration();
	public:  CmmExternDecl *  linkage_specification();
	public:  CmmDirective *  directive();
	public:  CmmNamespaceExtension *  namespace_extension();
	public:  CmmSpecSect *  constructor_decl_specifiers();
	public:  CmmNameExpr *  declarator_id();
	public:  CmmContFunctionDeclarator *  cont_function_declarator();
	public:  CmmCtorInitializer *  ctor_initializer();
	public:  CmmDeclarator *  declarator();
	public:  CmmHandlerSect *  handler_list();
	public:  CmmSpec *  constructor_decl_specifier();
	public:  CmmDeclSpec *  decl_specifiers();
	public:  CmmPtrSpecifierSect *  ptr_specifier_list();
	public:  CmmContDeclaratorSect *  cont_declarator_list();
	public:  CmmInitDeclarator *  init_declarator();
	public:  CmmInitializer *  initializer();
	public:  CmmSpecSect *  simple_decl_specifiers();
	public:  CmmTemplateArgSect *  template_arg_list();
	public:  CmmClassDecl *  class_specifier();
	public:  CmmEnumDecl *  enum_specifier();
	public:  CmmTypeSect *  simple_type_specifiers();
	public:  CmmSpec *  simple_decl_specifier();
	public:  CmmType *  simple_type_specifier();
	public:  CmmAllocTypeSpec *  alloc_type_specifier();
	public:  CmmEnumSect *  enum_list();
	public:  CmmEnumItem *  enumerator();
	public:  string  string_literal();
	public:  CmmAbstractDeclarator *  abstract_declarator();
	public:  CmmCommonTypeId *  common_type_id();
	public:  CmmCommonDeclarator *  common_declarator();
	public:  CmmContDeclarator *  cont_declarator();
	public:  CmmContArrayDeclarator *  cont_array_declarator();
	public:  CmmParamSect *  parameter_declaration_list();
	public:  CmmCvSpecifierSect *  cv_specifier_list();
	public:  CmmExceptionSpec *  exception_specification();
	public:  CmmPtrSpecifier *  ptr_specifier();
	public:  CmmCvSpecifier *  cv_specifier();
	public:  CmmParamItem *  parameter_declaration();
	public:  CmmInitItem *  initializer_item();
	public:  CmmInitSimple *  simple_initializer();
	public:  CmmInitList *  initializer_list();
	public:  CmmBaseSect *  base_specifier_list();
	public:  CmmDeclSect *  member_list();
	public:  CmmDecl *  member_item();
	public:  CmmMemberVisibility *  member_visibility();
	public:  CmmSimpleDecl *  member_declaration();
	public:  CmmInitDeclarator *  member_declarator();
	public:  CmmBaseItem *  base_specifier();
	public:  CmmMemberInitializer *  mem_initializer();
	public:  CmmTemplateParamSect *  template_param_list();
	public:  CmmTemplateParam *  template_param();
	public:  CmmTemplateExtraParam *  template_extra_param();
	public:  CmmTemplateTypeParam *  template_type_param();
	public:  CmmTemplateValueParam *  template_value_param();
	public:  CmmTemplateArg *  template_arg();
	public:  CmmTemplateTypeArg *  template_type_arg();
	public:  CmmTemplateValueArg *  template_value_arg();
	public:  CmmHandlerItem *  handler();
	public:  CmmExceptionDecl *  exception_declaration();
	public:  string  dir_start();
	public:  string  dir_end();
	public:  string  dir_ident();
	public:  string  dir_number();
	public:  string  dir_q_string();
	public:  string  dir_h_string();
	public:  CmmIncludeName *  include_name();
	public:  CmmClusterStat *  cluster_stat();
	public:  CmmClassDecl *  class_declaration();
	public:  CmmEnumDecl *  enum_declaration();
	public:  CmmDefineSect *  define_part();
	public:  CmmTextSect *  text_section();
	public:  string  numeric_literal();
	public:  CmmTextItem *  text_item();
	public:  string  txt_token();
	public:  string  txt_white_space();
	public:  string  txt_new_line();
	public:  string  txt_other();
	public:  CmmDefineItem *  define_item();
	public:  CmmWhenItem *  when_item();
	public:  AltName *  alt_name();
	public:  AltSimple *  alt_simple();
	public:  AltExpr *  alt_expression();
	public:  AltBranch *  alt_branch();
	public:  DefItem *  alt_item();
	public:  DefList *  alt_list();
	public:  DefItem *  def_item();
	public:  DefList *  def_list();
	public:  LogFactor *  log_factor();
	public:  LogExpr *  log_expression();
	public:  LogTerm *  log_term();
	public:  LogStat *  log_statement();
	public:  NumStatSect *  num_statements();
	public:  NumStat *  num_statement();
	public:  NumAssign *  num_assign();
	public:  NumCode *  num_code();
	public:  NumWhen *  num_when();
	public:  NumIndent *  num_indent();
	public:  NumUnindent *  num_unindent();
	public:  NumCond *  num_cond();
	public:  NumStatAlternative *  num_stat_alternative();
	public:  NumSelection *  num_selection();
	public:  NumExprAlternative *  num_expr_alternative();
	public:  NumAndCond *  num_and_cond();
	public:  NumCompCond *  num_comp_cond();
public:
	antlr::RefAST getAST()
	{
		return returnAST;
	}
	
protected:
	antlr::RefAST returnAST;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 201;
#else
	enum {
		NUM_TOKENS = 201
	};
#endif
	
	static const unsigned long _tokenSet_0_data_[];
	static const antlr::BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const antlr::BitSet _tokenSet_1;
	static const unsigned long _tokenSet_2_data_[];
	static const antlr::BitSet _tokenSet_2;
	static const unsigned long _tokenSet_3_data_[];
	static const antlr::BitSet _tokenSet_3;
	static const unsigned long _tokenSet_4_data_[];
	static const antlr::BitSet _tokenSet_4;
	static const unsigned long _tokenSet_5_data_[];
	static const antlr::BitSet _tokenSet_5;
	static const unsigned long _tokenSet_6_data_[];
	static const antlr::BitSet _tokenSet_6;
	static const unsigned long _tokenSet_7_data_[];
	static const antlr::BitSet _tokenSet_7;
	static const unsigned long _tokenSet_8_data_[];
	static const antlr::BitSet _tokenSet_8;
	static const unsigned long _tokenSet_9_data_[];
	static const antlr::BitSet _tokenSet_9;
	static const unsigned long _tokenSet_10_data_[];
	static const antlr::BitSet _tokenSet_10;
	static const unsigned long _tokenSet_11_data_[];
	static const antlr::BitSet _tokenSet_11;
	static const unsigned long _tokenSet_12_data_[];
	static const antlr::BitSet _tokenSet_12;
	static const unsigned long _tokenSet_13_data_[];
	static const antlr::BitSet _tokenSet_13;
	static const unsigned long _tokenSet_14_data_[];
	static const antlr::BitSet _tokenSet_14;
	static const unsigned long _tokenSet_15_data_[];
	static const antlr::BitSet _tokenSet_15;
	static const unsigned long _tokenSet_16_data_[];
	static const antlr::BitSet _tokenSet_16;
	static const unsigned long _tokenSet_17_data_[];
	static const antlr::BitSet _tokenSet_17;
	static const unsigned long _tokenSet_18_data_[];
	static const antlr::BitSet _tokenSet_18;
	static const unsigned long _tokenSet_19_data_[];
	static const antlr::BitSet _tokenSet_19;
	static const unsigned long _tokenSet_20_data_[];
	static const antlr::BitSet _tokenSet_20;
	static const unsigned long _tokenSet_21_data_[];
	static const antlr::BitSet _tokenSet_21;
	static const unsigned long _tokenSet_22_data_[];
	static const antlr::BitSet _tokenSet_22;
	static const unsigned long _tokenSet_23_data_[];
	static const antlr::BitSet _tokenSet_23;
	static const unsigned long _tokenSet_24_data_[];
	static const antlr::BitSet _tokenSet_24;
	static const unsigned long _tokenSet_25_data_[];
	static const antlr::BitSet _tokenSet_25;
	static const unsigned long _tokenSet_26_data_[];
	static const antlr::BitSet _tokenSet_26;
	static const unsigned long _tokenSet_27_data_[];
	static const antlr::BitSet _tokenSet_27;
	static const unsigned long _tokenSet_28_data_[];
	static const antlr::BitSet _tokenSet_28;
	static const unsigned long _tokenSet_29_data_[];
	static const antlr::BitSet _tokenSet_29;
};

ANTLR_END_NAMESPACE
#endif /*INC_CMMParser_hpp_*/
